Attribute VB_Name = "Module1"
Option Explicit
Declare Function EnumDisplaySettings Lib "USER32" Alias "EnumDisplaySettingsA" (ByVal lpszDeviceName As Long, ByVal iModeNum As Long, lptypDevMode As Any) As Boolean
Declare Function ChangeDisplaySettings Lib "USER32" Alias "ChangeDisplaySettingsA" (lptypDevMode As Any, ByVal dwFlags As Long) As Long
Public Declare Function GetTickCount Lib "kernel32" () As Long

Public Const EWX_LOGOFF = 0
Public Const EWX_SHUTDOWN = 1
Public Const EWX_REBOOT = 2
Public Const EWX_FORCE = 4
Public Const CCDEVICENAME = 32
Public Const CCFORMNAME = 32
Public Const DM_BITSPERPEL = &H40000
Public Const DM_PELSWIDTH = &H80000
Public Const DM_PELSHEIGHT = &H100000
Public Const CDS_UPDATEREGISTRY = &H1
Public Const CDS_TEST = &H4
Public Const DISP_CHANGE_SUCCESSFUL = 0
Public Const DISP_CHANGE_RESTART = 1

Public Type typDevMODE
dmDeviceName       As String * CCDEVICENAME
dmSpecVersion      As Integer
dmDriverVersion    As Integer
dmSize             As Integer
dmDriverExtra      As Integer
dmFields           As Long
dmOrientation      As Integer
dmPaperSize        As Integer
dmPaperLength      As Integer
dmPaperWidth       As Integer
dmScale            As Integer
dmCopies           As Integer
dmDefaultSource    As Integer
dmPrintQuality     As Integer
dmColor            As Integer
dmDuplex           As Integer
dmYResolution      As Integer
dmTTOption         As Integer
dmCollate          As Integer
dmFormName         As String * CCFORMNAME
dmUnusedPadding    As Integer
dmBitsPerPel       As Integer
dmPelsWidth        As Long
dmPelsHeight       As Long
dmDisplayFlags     As Long
dmDisplayFrequency As Long
End Type

Public typDevM As typDevMODE
Public lngResult As Long
Public origxres As Integer
Public origyres As Integer
Public origbpp As Integer
Public confirmation As Byte

Public Sub ChangeResolution(newxres As Integer, newyres As Integer, newbpp As Integer)
Dim oldxres As Integer
Dim oldyres As Integer
Dim oldbpp As Integer

origxres = Screen.Width / Screen.TwipsPerPixelX
origyres = Screen.Height / Screen.TwipsPerPixelY
origbpp = 32

lngResult = EnumDisplaySettings(0, 0, typDevM)

With typDevM
.dmFields = DM_PELSWIDTH Or DM_PELSHEIGHT Or DM_BITSPERPEL
.dmPelsWidth = newxres
.dmPelsHeight = newyres
.dmBitsPerPel = newbpp
End With

lngResult = ChangeDisplaySettings(typDevM, CDS_TEST)

endthis:
End Sub

